/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// VideoSetupDlg.h : header file
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//{{AFX_INCLUDES()
#include "webbrowser2.h"
//}}AFX_INCLUDES

#if !defined(AFX_VIDEOSETUPDLG_H__E86FEC97_DFA5_400F_938A_65EB549BC742__INCLUDED_)
#define AFX_VIDEOSETUPDLG_H__E86FEC97_DFA5_400F_938A_65EB549BC742__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CVideoSetupDlg dialog
class CVideoSetupDlg : public CDialog
{
private:
	char		m_szIP[255];
	char		m_szUserID[255];
	char		m_szPasswd[255];

	//..................................................
	// Construction
public:
	CVideoSetupDlg(CWnd* pParent = NULL);	// standard constructor
	virtual ~CVideoSetupDlg();

	//..................................................

public:
	
	void Init();
	void SetLoginInfo( char *szAddr, char *szUserID, char *szPasswd );

	//..................................................
	// Dialog Data
	//{{AFX_DATA(CVideoSetupDlg)
	enum { IDD = IDD_DIALOG_VIDEO_SETUP };
	CWebBrowser2	m_webBrowser;
	//}}AFX_DATA

	//..................................................
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVideoSetupDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

	//..................................................
	// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CVideoSetupDlg)
	afx_msg void OnButtonVideo();
	afx_msg void OnButtonTcpip();
	afx_msg void OnButtonDdns();
	afx_msg void OnButtonStatus();
	afx_msg void OnButtonAlarminput();
	afx_msg void OnButtonMd();
	afx_msg void OnButtonSchedule();
	afx_msg void OnButtonTransfersetup();
	afx_msg void OnButtonFtp();
	afx_msg void OnButtonSmtp();
	afx_msg void OnButtonUsers();
	afx_msg void OnButtonDatetime();
	afx_msg void OnButtonFirmwareupdate();
	afx_msg void OnButtonDefaultset();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SVIDEOSETUPDLG_H__E86FEC97_DFA5_400F_938A_65EB549BC742__INCLUDED_)
