#if !defined(AFX_VIDEOVIEW_H__A0ADA9DB_C152_4EA3_9927_27061694F1DF__INCLUDED_)
#define AFX_VIDEOVIEW_H__A0ADA9DB_C152_4EA3_9927_27061694F1DF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// VideoView.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVideoView window
#include "VideoDraw.h"
class CVideoDraw;

class CVideoView : public CWnd
{
private:
	CRect	m_rectMT_Temp;
	BOOL  m_isMouseDown;

	DWORD m_dwWWidth;
	DWORD m_dwWHeight;
	DWORD m_dwImageWidth;
	DWORD m_dwImageHeight;

	CVideoDraw *m_pVideo;
// Construction
public:
	CVideoView();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVideoView)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CVideoView();

	void Init(HWND hWnd, DWORD dwWWidth, DWORD dwWHeight);
	void DrawImage(BYTE *lpData, DWORD dwWidth, DWORD dwHeight, BYTE *lpMotionInfo=NULL, DWORD dwMotionInfoSize=0);
	void DrawMotionArea(BYTE *lpMotonInfo,  DWORD dwSize);
	
	void ShowMotionArea(BOOL bShow);
	void SetMotionInfo(BYTE *lpData,  DWORD dwSize);
	BOOL GetMotionInfo(BYTE *lpData,  DWORD &dwSize);

	// Generated message map functions
protected:
	//{{AFX_MSG(CVideoView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VIDEOVIEW_H__A0ADA9DB_C152_4EA3_9927_27061694F1DF__INCLUDED_)
