// WaveInUtil.h: interface for the CWaveInUtil class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVEINUTIL_H__5931749E_7434_44BF_B563_AAF469049C5C__INCLUDED_)
#define AFX_WAVEINUTIL_H__5931749E_7434_44BF_B563_AAF469049C5C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SoundCaptureManager.h"



class CWaveInUtil  
{
private:
	CSoundCaptureManager *m_pMyDS;
	int m_nChannel;
	int m_nSamplesPerSec;
	int m_nBitsPerSample;
public:
	void Stop();
	void Start();
	void InitSoundCapture(LPFNC_CAPTUREDATA Function_Callback, LPVOID lpCallbackData);
	CWaveInUtil(int nChannel=1, int nSamplesPerSec=8000, int nBitsPerSample=16);
	virtual ~CWaveInUtil();

};

/*
HRESULT CALLBACK GetSamples(LPBYTE lpDesBuf, const DWORD dwRequiredSamples, DWORD &dwRetSamples, LPVOID lpData)
{
	CDirectSoundTestDlg *pDlg = (CDirectSoundTestDlg *)lpData;
	pDlg->GetAudioSamples(lpDesBuf, dwRequiredSamples, dwRetSamples);
	return 0;
}
*/

#endif // !defined(AFX_WAVEINUTIL_H__5931749E_7434_44BF_B563_AAF469049C5C__INCLUDED_)
