// WaveOutUtil.h: interface for the CWaveOutUtil class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WAVEOUTUTIL_H__216CA1BD_DA0A_4852_BA1F_A0D4A80FA085__INCLUDED_)
#define AFX_WAVEOUTUTIL_H__216CA1BD_DA0A_4852_BA1F_A0D4A80FA085__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "Dsutil.h"



class CWaveOutUtil  
{
private:
	BOOL m_bPlaying;
	int m_nChannel;
	int m_nSamplesPerSec;
	int m_nBitsPerSample;
public:
	int MonitorPos();
	BOOL IsSoundPlaying();
	void StopVoice();
	void InitSoundPlay();
	HWND m_pHwnd;
	void PlayVoice(BYTE * pData,int nSize);
	void EndVoice();
	void InitSoundPlay(HWND wnd);
	WAVEFORMATEX    m_wfxInput;
	//WAVEFORMATEX  m_wfxInput;
	CSoundManager * m_pSoundManager;	//Live play
	CSound		  * m_pSound;			//Live play


	BYTE * m_pPlayAudBuf;
	BYTE * m_pCapAudBuf;
	int    m_iAudWritePos;
	int	   m_iAudBufCnt;

	CWaveOutUtil(int nChannel=1, int nSamplesPerSec=8000, int nBitsPerSample=16);
	virtual ~CWaveOutUtil();

};

#endif // !defined(AFX_WAVEOUTUTIL_H__216CA1BD_DA0A_4852_BA1F_A0D4A80FA085__INCLUDED_)
