// GLOBALUTILS_DLL.h: interface for the GLOBALUTILS_DLL class.
//
//////////////////////////////////////////////////////////////////////
 
#if !defined(AFX_GLOBALUTILS_DLL_H__04298C41_A075_4FAE_9089_C341FD0F1994__INCLUDED_)
#define AFX_GLOBALUTILS_DLL_H__04298C41_A075_4FAE_9089_C341FD0F1994__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef _GLOBALUTILS_DLL_
	#define API_GLOBALUTILS extern  __declspec(dllexport)
#else
	#define API_GLOBALUTILS extern  __declspec(dllimport)
	#ifdef _DEBUG
		#pragma comment(lib, "../libd/GLOBALUTILS.lib")
		#pragma message("Automatically linking with GLOBALUTILS.lib")
	#else
		#pragma comment(lib, "../lib/GLOBALUTILS.lib")
		#pragma message("Automatically linking with GLOBALUTILS.lib")
	#endif
#endif
	API_GLOBALUTILS void ANALYZERECT(LPSTR lStr,RECT * reRet);
	API_GLOBALUTILS void ANALYZERGB(LPSTR lStr,COLORREF * pRgb);
	API_GLOBALUTILS void GETINIFILESTRING(LPSTR strPath, LPSTR strSection, LPSTR strKey, LPSTR strDef, char *pBuff);
	API_GLOBALUTILS void GETINIFILEINT(LPSTR strPath, LPSTR strSection, LPSTR strKey, int nDef,int & nRet);
	API_GLOBALUTILS void GETINIFILERECT(LPSTR strPath, LPSTR strSection, LPSTR strKey,LPRECT pRect);
	API_GLOBALUTILS void SETINIFILESTRING(LPSTR strPath, LPSTR strSection, LPSTR strKey, LPSTR strData);
	API_GLOBALUTILS void SETINIFILEINT(LPSTR strPath, LPSTR strSection, LPSTR strKey, int nValue);
	API_GLOBALUTILS void SETINIFILERECT(LPSTR strPath, LPSTR strSection, LPSTR strKey,LPRECT pRect);
	API_GLOBALUTILS void GETCONSTCURTIME(CTime & retTime);
	API_GLOBALUTILS CTime GETCURRENTTIME();
	API_GLOBALUTILS void DRAWCOLORCUBE(HDC hDC, CRect& rect, COLORREF colorFrom, COLORREF colorTo /*= RGB(255,255,255)*/, BOOL IsHori/* = true*/);
	API_GLOBALUTILS HANDLE  MAKEDIB( HBITMAP hbitmap, UINT bits );

	API_GLOBALUTILS void ENCRYPTPROC(LPBYTE pBuf, int nBuflen, LPSTR pPW);
	API_GLOBALUTILS void DECRYPTPROC(LPBYTE pBuf, int nBuflen, LPSTR pPW);

	API_GLOBALUTILS	void DrawShadeText(HDC hDC, CRect re, LPSTR str, COLORREF rgb, UINT nFormat);

	API_GLOBALUTILS	void YUY2_Resize_w2h2(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height); //Width Height 1/2 
	API_GLOBALUTILS	void YUY2_Resize_w4h2(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height); //Width Height 1/4 
	API_GLOBALUTILS	void YUY2_Resize_w2(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height)  ; //Width          1/2 

//----------------------------------------------------------------------------------------------------------------------------------
enum COLORFORMAT {
	CF_NOTDEFINED = 0,
	CF_YUY2,
	CF_BGRX,
	CF_BGR,
	CF_BGR565,
	CF_BGR555,
};
enum RGBpixelType { RGB565, RGB555, RGB24bpp, RGB32bpp };

	API_GLOBALUTILS	void YUY2_To_RGB32				(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB32_Resize_2		(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB32_Resize_4		(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB555				(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB555_Resize_2	(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB555_Resize_2_2	(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB555_Resize_4	(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB24_QAligned		(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB24_DQAligned	(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_Resize_2				(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_Resize_4				(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);



	API_GLOBALUTILS	void YUY2_To_RGB32_SSE			(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB32_Resize_2_SSE	(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB32_Resize_4_SSE	(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB555_SSE			(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB555_Resize_2_SSE(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB555_Resize_4_SSE(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);

	API_GLOBALUTILS	void YUY2_To_RGB565				(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB565_Resize_2_2	(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB565_SSE			(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);
	API_GLOBALUTILS	void YUY2_To_RGB565_Resize_2_SSE(BYTE* src,BYTE* dst,DWORD pitch,DWORD width,DWORD height);

	API_GLOBALUTILS	BOOL ConvertColorFormat(BYTE* psrc,COLORFORMAT src_format,BYTE* pdst,DWORD dst_pitch,RGBpixelType dst_format,SIZE roi,DWORD scale_factor);

//----------------------------------------------------------------------------------------------------------------------------------
	API_GLOBALUTILS	BOOL SETWEBPORT(LPSTR szConfig, int nPort);
	API_GLOBALUTILS	int  GETWEBPORT(LPSTR szConfig);
	API_GLOBALUTILS void ISSE_YUY2_TO_YV12(BYTE* src, int src_rowsize, int src_pitch,BYTE* dstY,BYTE* dstU,BYTE* dstV, int dst_pitchY, int dst_pitchUV,int height) ;
	API_GLOBALUTILS void MMX_YUY2_TO_YV12(const BYTE* src, int src_rowsize, int src_pitch,BYTE* dstY, BYTE* dstU, BYTE* dstV, int dst_pitchY, int dst_pitchUV,int height);
	API_GLOBALUTILS void ISSE_YV12_TO_YUY2(const BYTE* srcY, const BYTE* srcU, const BYTE* srcV, int src_rowsize, int src_pitch, int src_pitch_uv,BYTE* dst, int dst_pitch,int height);
	API_GLOBALUTILS BOOL SETTRANSPARENT(HWND hWnd, COLORREF crKey, BYTE bAlpha);
	API_GLOBALUTILS BOOL SETTRANSPARENTEX(HWND hWnd, COLORREF crKey, BYTE bAlpha, DWORD dwFlags);

	/*************************************************************************
	/	Ƽ  Լ
	****************************************************************************/
//	API_GLOBALUTILS int			_UTIL_GETMONITORCOUNT();
//	API_GLOBALUTILS HMONITOR	_UTIL_GETMONITORFROMRECT(LPRECT lprc);
//	API_GLOBALUTILS HMONITOR	_UTIL_GETMONITORFROMPOINT(POINT pt);
//	API_GLOBALUTILS HMONITOR	_UTIL_GETMONITORFROMWINDOW(HWND hWnd);
//	API_GLOBALUTILS HMONITOR	_UTIL_GETMONITOR(int nIndex);
//	API_GLOBALUTILS HMONITOR	_UTIL_GETPRIMARYMONITOR();
//	API_GLOBALUTILS BOOL		_UTIL_GETMONITORDEVICE(HMONITOR hMonitor, char *lpBuff);
//	API_GLOBALUTILS BOOL		_UTIL_GETMONITORRECT(HMONITOR hMonitor, LPRECT lprc);
//	API_GLOBALUTILS BOOL		_UTIL_GETWORKAREA(HMONITOR hMonitor, LPRECT lprc);
//	API_GLOBALUTILS BOOL		_UTIL_GETBITSPERPIXEL(HMONITOR hMonitor, int &nBitPixel);
//	API_GLOBALUTILS BOOL		_UTIL_ISPRIMARYMONITOR(HMONITOR hMonitor);
//	API_GLOBALUTILS void		_UTIL_SETCENTERWINDOWTOMONITOR(HWND hWnd, HMONITOR hMonitor, BOOL UseWorkAreaRect);
	
#endif // !defined(AFX_GLOBALUTILS_DLL_H__04298C41_A075_4FAE_9089_C341FD0F1994__INCLUDED_)
