// ProbeNetCtrlrDef.h: interface for the CProbeNetCtrlrDef class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROBENETCTRLRDEF_H__A2193654_CA20_40DF_BC29_75544BE861D8__INCLUDED_)
#define AFX_PROBENETCTRLRDEF_H__A2193654_CA20_40DF_BC29_75544BE861D8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define _PROBE_SOCK_CONNECT_SUCCESS           0		//	Ἲ
#define _PROBE_SOCK_CONNECT_FAILED            -1	//	
#define _PROBE_SOCK_CONNECT_NOTAVAIL          -2	//	ȿ ּҰ ƴ
#define _PROBE_SOCK_CONNECT_FAULT             -3	//	߸ּ
#define _PROBE_SOCK_CONNECT_TIMEOUT           -4	//	ðʰ
#define _PROBE_SOCK_DISCONNECTED			  -5	//  
#define _PROBE_SOCK_STREAM_LOSS				  -6	//  ̵ Ʈ  

#define	MAX_VIDEO_BUFFER_SIZE	1400
#define STARTCODE	"STRT"
#define ENDCODE		"_END"

#define STARTCODE_SIZE		5
#define ENDCODE_SIZE		5
#define PS_SIZE				4
#define COMMCODE_SIZE		4
#define RANDOMCONST_SIZE	4
#define USERID_SIZE			20
#define PASSWD_SIZE			20
#define CTR_SIZE			1

#define	PARAM_ADDRESS		(0x000001)
#define	PARAM_PORT			(0x000002)
#define	PARAM_USERID		(0x000003)
#define	PARAM_PASSWD		(0x000004)
#define	PARAM_RANDOMCONST	(0x000005)


/*
web port : 80
control port : 7777
video port : 7778
audio port : 7779
audio send port : 7780
*/

#define CAMERA_CONFIG_COMMAND_CODE	"RSD"	
#define PTZ_COMMAND_CODE			"PTZ"
#define MOTION_MODE_COMMAND_CODE	"SDM"
#define ALARM_INOUT_COMMAND_CODE	"AGN"

//=======================================================
//  PTZ-Control Command
//=======================================================
#define PTZ_PTU						20		//up
#define PTZ_PTD 					21		//down
#define PTZ_PTL 					22		//left
#define PTZ_PTR 					23		//right
#define PTZ_ZMT 					24		//zoom in (tele)
#define PTZ_ZMW 					25		//zoom out (wide)
#define PTZ_FOF 					26		//focus far
#define PTZ_FON 					27		//focus near
#define PTZ_IRO 					28		//iris open
#define PTZ_IRC 					29		//iris close
#define PTZ_AFC 					30		//auto focus on
#define PTZ_AIR 					31		//auto iris  on
#define PTZ_MHO 					32		//Move home
#define PTZ_MRU 					33		//Move Right Up
#define PTZ_MRD 					34		//Move Right Down
#define PTZ_MLD 					35		//Move Left Down
#define PTZ_MLU 					36		//Move Left Up
#define PTZ_MCO 					37		//Move Coordinate
#define PTZ_STA 					40		//stop for all
#define PTZ_STU 					41		//stop for up ()
// Add by lsm. 20100617 : Lion, Prob⿡ PTZ Stop  41 ٲ.
#define PTZ_STOP					41
// End.
#define PTZ_STD 					42		//stop for down
#define PTZ_STL 					43		//stop for left
#define PTZ_STR 					44		//stop for right
#define PTZ_STT 					45		//stop for tele ()
#define PTZ_STW 					46		//stop for wide
#define PTZ_STF 					47		//stop for far
#define PTZ_STN 					48		//stop for near
#define PTZ_STO 					49		//stop for open
#define PTZ_STC 					50		//stop for close
#define PTZ_SAF 					51		//stop for AF
#define PTZ_SAI 					52		//stop Auto IRIS
#define PTZ_SRU 					53		//stop for Right Up
#define PTZ_SRD 					54		//stop for Right Down
#define PTZ_SLD 					55		//stop for Left Down
#define PTZ_SLU 					56		//stop fir Left Up
#define PTZ_PON 					60		//power on
#define PTZ_POF 					61		//power off
#define PTZ_LON 					62		//light on
#define PTZ_LOF 					63		//light off
#define PTZ_AON 					64		//aux on
#define PTZ_AOF 					65		//aux off
#define PTZ_INI 					66		//Initialize
#define PTZ_RST 					67		//Reset
#define PTZ_WON 					68		//Wiper On
#define PTZ_WOF 					69		//Wiper Off
#define PTZ_APS 					70		//auto pan start
#define PTZ_APE 					71		//auto pan end
#define PTZ_AP1 					72		//position 1
#define PTZ_AP2 					73		//position 2
#define PTZ_PST 					74		//preset set
#define PTZ_PMV 					75		//preset move
#define PTZ_PAS 					76		//preset autoscan
#define PTZ_PAE 					77		//preset autoscan end

#define	PTZ_TUR						78		//Tour Run 			<< add 06-02-23
#define PTZ_SWING					79		//Set Swing Move 	<< add 06-02-23
#define PTZ_GROUP					80		//Set Group Move	<< add 06-02-23
#define PTZ_TUS						81		//Tour Stop			<< add 06-02-23

#define PTZ_SPAN					100		//Pan Position Status
#define PTZ_STILT					101		//Tilt Position Status
#define PTZ_SDIN					102		//In Status
#define PTZ_SDOUT					103		//Out Status

#define PTZ_PAD						104		//Preset Delete
#define PTZ_PT_SPEED				105		//Set PT Speed
#define PTZ_SET_DOUT				106     //Set Digital Output
#define PTZ_PATTERN					107		//Set Pattern
#define PTZ_OSD_MENU				108		//OSD Menu On


//Added by jmlee (05.04.12)
#define PTZ_PTG						110		//Power Toggle		<
#define	PTZ_LTG						111		//Light Toggle		<
#define PTZ_ATG						112		//Alarm Toggle		<
#define PTZ_AS_INT					113		//AutoScan Interval Time <

//Added by jmlee (05.05.12)
#define PTZ_DVR_FUNC				120		//For BluenetVideo DVR

//added by jmlee (07.03.28)
#define PTZ_CHNL_STATUS				121		//QUAD, current Channel			-->>>?????????
#define PTZ_AUTO_SCAN				122		//QUAD, auto scan 
#define PTZ_AUTO_SCAN_STATUS		123		//07.08.21, autoscan status.

//Added by sjPark 06.05.26
#define PTZ_SETPANPOS				125		//Set Pan position
#define PTZ_SETTILTPOS				126		//Set Tilit position
#define PTZ_SETZOOMPOS				127		//Set Zoom Position
#define PTZ_GETZOOMPOS				128		//Get Zoom Position

//Added by sjPark 06.06.12
#define PTZ_MOVPTZS					129		//Move Pan/Tilt/Zoom & Speed
#define PTZ_GETPTZPOS				130		//Get Pan/Tilt/Zoom Position 

//Added by jmlee (07.01.09 - samsung techwin)
#define PTZ_SETPANTILTPOS			131		//Set Pan & Tilt Position
#define PTZ_MCO2 					240		// Move Coordinate2 ( Power PTZ )

//=======================================================
// Parameter Define(PTZ)
//=======================================================
#define PM_PAN_MOVE_STOP			0
#define PM_PAN_MOVE_RIGHT			1
#define PM_PAN_MOVE_LEFT			2

#define PM_TILT_MOVE_STOP			0
#define PM_TILT_MOVE_UP				1
#define PM_TILT_MOVE_DOWN			2

#define PM_ZOOM_MOVE_STOP			0
#define PM_ZOOM_MOVE_WIDE			1
#define PM_ZOOM_MOVE_TELE			2

#define PM_FOCUS_MOVE_STOP			0
#define PM_FOCUS_MOVE_FAR			1
#define PM_FOCUS_MOVE_NEAR			2

#define PM_IRIS_MOVE_STOP			0
#define PM_IRIS_MOVE_OPEN			1
#define PM_IRIS_MOVE_CLOSE			2

#define PM_FOCUS_NONE_MODE			0
#define PM_FOCUS_AUTO_MODE			1

#define PM_IRIS_NONE_MODE			0
#define PM_IRIS_AUTO_MODE			1

#define PM_PRESET_NONE_MODE			0
#define PM_PRESET_AUTO_MODE			1

#pragma pack(1)

// Transmitting stream data
struct VIDEO_DATA_PACK 
{
	unsigned char	m_isCompMode;	// 0, 1, 2, 3   10
	unsigned long	m_nFrame_Num;
	unsigned long	m_nFrame_Size;
	unsigned short	m_nSlice_Num;
	unsigned short	m_nSlice_Size;

	unsigned char   m_nChannelInfo;
	unsigned char   m_nResolution_Id : 6;	
	unsigned char   m_nVideo_type	 : 2;		// NTSC : 1, PAL : 2
	//unsigned char   m_nReserved;
//	unsigned short	m_nFrame_ID;
	//unsigned long	m_nFrame_Gop;
	unsigned long	m_nSystemTime;
	unsigned short	m_nFrame_Gop_Num;
	unsigned short	m_nFrame_type;

	unsigned char	m_szFrameData[MAX_VIDEO_BUFFER_SIZE];
};

#define AUDIO_CODEC_G711_16K  0x31
#define AUDIO_CODEC_G711_8K   0x11

struct AUDIO_DATA_PACK 
{
	unsigned char	m_isCompMode;		// 0x31 = g.711(8bit, mono, 16000 samplerate), 0x11 = g.711(8bit, mono, 8000 samperate)
	unsigned long	m_nFrame_Num;
	unsigned long	m_nFrame_Size;
	unsigned short	m_nSlice_Num;		
	unsigned short	m_nSlice_Size;		

	unsigned char   m_nChannelInfo;
	unsigned char   m_nResolution_Id;	

	unsigned long	m_nFrame_Gop;		
	unsigned short	m_nFrame_Gop_Num;	
	unsigned short	m_nFrame_type;		

	unsigned char	m_szFrameData[MAX_VIDEO_BUFFER_SIZE];
};


// connection success message
struct CONN_SUCC_MSG
{
	unsigned char	m_szStartCode[5];	// SC	
	unsigned char	m_szPackSize[4];	// PS
	unsigned char	m_szCommCode[4];	// CMD
	unsigned char	m_Empty;			// '\0'
	unsigned char	m_szEndcode[5];		// EC
};

// user authentication request
struct USER_AUTH_REQ
{
	unsigned char	m_szStartCode[5];	// SC	
	unsigned char	m_szPackSize[4];	// PS
	unsigned char	m_szCommCode[4];	// CMD
	unsigned char	m_szID[20];
	unsigned char	m_szPassword[20];
	unsigned char	m_szEndcode[5];	// EC	
};

// reply to user authentication request
struct USER_AUTH_REPLY
{
	unsigned char	m_szStartCode[5];	// SC	
	unsigned char	m_szPackSize[4];	// PS
	unsigned char	m_szCommCode[4];	// CMD
	unsigned char	m_szRamdomCnst[4];	// RAMDOM CONST
	unsigned char	m_szEndcode[5];		// EC
};

// disconnection message
struct DISCONN_MSG
{
	unsigned char	m_szStartCode[5];	// SC	
	unsigned char	m_szPackSize[4];	// PS
	unsigned char	m_szCommCode[4];	// CMD
	unsigned char	m_szRamdomCnst[4];	// RAMDOM CONST
	unsigned char	m_szEndcode[5];		// EC
};

// check server status
struct CHECK_STATUS
{
	unsigned char	m_szStartCode[5];	// SC	
	unsigned char	m_szPackSize[4];	// PS
	unsigned char	m_szCommCode[4];	// CMD
	unsigned char	m_Empty;			// '\0'
	unsigned char	m_szEndcode[5];		// EC
};

struct CONNECTION_INFO
{
	char m_szAddress[48];
	WORD m_wControlPort;
	WORD m_wVideoPort;
	WORD m_wAudioPort;
	WORD m_wMikePort;

	char m_szUserId[USERID_SIZE];
	char m_szPassWd[PASSWD_SIZE];
};

// Add by lsm. 20100618 : 
struct CAMERA_CONFIG
{
	unsigned char Channel;				// 
	unsigned char ntsc_pal;				// 0:NTSC,  1:PAL
	unsigned short cbr_value;         	// 0 ~ 1023
	unsigned char resolution;			// 0 : CIF, 1 : D1
	unsigned char quality;				// 1 ~ 31
	unsigned char encode_mode;			// 0 : vbr, 1 : cbr
	unsigned char compress_mode;		// 0 : MJPEG, 1 : MPEG
	unsigned char frame_rate;			// 1 ~ 30
	unsigned char mount_type;			// 0 : normal, 1 : flip 
	unsigned char ptz_direction;		// 0 : normal, 1 : reverse
	unsigned char image_control;		// 0 : play, 1 : stop
	unsigned char camera_name[16];		// "cam"
	unsigned char camera_macaddress[18];	// MAC Address
};
/*
struct CAMERA_CONFIG
{
	char 	m_strCamName;
	int		m_nBrightness;
	int		m_nVideoType;
	int		m_nConstBitRateValue;
	int		m_nResolution;				
	int		m_nImageQuality;			// 1 ~ 31
	int		m_nEncodingVideoMode;		// byQuality, byBandwidth
	int		m_nImageEncodingOption;		// ieIPicRef, ieStandard
	int		m_nVideoCompressMethod;		// ctMJPEG_MD_PENTA, ctMPEG4_MD_PENTA, ctMPEG4_MD_DM365, ctH264_MD_DM365, ctMJPEG_DM365
	BOOL	m_bPantTiltReverseMotion;
	int		m_nVideoFrameRate;
	int		m_nCameraMountType;			// cmNormal, cmFlip
	BOOL	m_bStreaming;
};
*/

#define ENCODE_SETUP_CHANNEL_COUNT  5
#define ENCODE_SETUP_TXT_LENGTH		32
struct ENCODE_SETUP_INFO
{
	BYTE	m_ch;				// setup channel number : 0~4
	DWORD   m_codec_type;		// codec type : (0:none, 1:h264, 2:mpeg4, 4:mjpeg) 0~3
	DWORD	m_framerate;		// frame rate (ntsc:30, pal:25) 1~30
	DWORD	m_max_framerate;	// max frame rate (ntsc:30, pal:25) 25/30
	DWORD	m_bitrate_mode;		// bit rate mode (VBR:0, CBR:1) 0~1
	DWORD	m_bitrate;			// bit rate (1~5Mbps)		1~5
	DWORD	m_quality;			// quality(1:best~5:worst)	1~5
	DWORD	m_resolution;		// resolution (0:1080i, 1:720p, 2:D1, 3:CIF, 4:QCIF) 0~4	
	DWORD	m_gop_interval;		// gop interval(1~30 default:15) 1~30
								// Framerate 10̸   gop = Framerate; 
								// Framerate 10̻̰ gop 10̸̸ gop = 15
								// framerate 10̻̰ gop 10̸̻ 
								// , framerate  ʾҰ gop Ͽ  gop ״ 	
	DWORD	m_priority;			// not yet
	DWORD	m_quantizer;		// not yet
	char	m_video_name[ENCODE_SETUP_TXT_LENGTH];
	char	m_codec_name[ENCODE_SETUP_TXT_LENGTH];
	BYTE	m_reserved[ENCODE_SETUP_TXT_LENGTH];
};


#pragma pack()

#define _CONTROL_SOCK		0x01
#define _VIDEO_SOCK			0x02
#define _AUDIO_SOCK			0x04
#define _AUDIOSEND_SOCK		0x08

typedef void (*LPSOCKETFUNC_ON_RECV_AUDIO_DATA)(HANDLE hCallback, AUDIO_DATA_PACK *lpData);
typedef void (*LPSOCKETFUNC_ON_RECV_VIDEO_DATA)(HANDLE hCallback, VIDEO_DATA_PACK *lpData, DWORD_PTR param1, DWORD_PTR param2);
typedef void (*LPSOCKETFUNC_ON_RECV_CTRL_DATA)(HANDLE hCallback, char *szCommandCode, DWORD_PTR param1, DWORD_PTR param2);
typedef void (*LPSOCKETFUNC_ON_ERROR)(HANDLE hCallback, int nErrorCode);


#endif // !defined(AFX_PROBENETCTRLRDEF_H__A2193654_CA20_40DF_BC29_75544BE861D8__INCLUDED_)
