#pragma once

#include "IPCamDecoderDll_ErrorCode.h"

extern "C" __declspec(dllimport)	HANDLE	IPCAM_Decoder_Init();
extern "C" __declspec(dllimport)	int	IPCAM_Decoder_Decode(HANDLE dwID, BYTE* pBuf, BYTE* pOutImage, DWORD dwLen, int* nWidth, int* nHeight, BOOL bIRef);
extern "C" __declspec(dllimport)	int	IPCAM_Decoder_DecodeRGB24(HANDLE dwID, BYTE* pBuf, BYTE* pOutImage, DWORD dwLen, int* nWidth, int* nHeight, BOOL bIRef);
extern "C" __declspec(dllimport)	int	IPCAM_Decoder_GetDimension(HANDLE dwID, BYTE* pBuf, DWORD dwLen, int* nWidth, int* nHeight);
extern "C" __declspec(dllimport)	int	IPCAM_Decoder_Close(HANDLE dwID);

typedef	HANDLE	(*LPIPCAM_DECODER_INT_FNC)();
typedef	int		(*LPIPCAM_DECODER_CLOSE_FNC)(HANDLE dwID);
typedef	int		(*LPIPCAM_DECODER_Decode_FNC)(HANDLE dwID, BYTE* pBuf, BYTE** pOutImage, DWORD dwLen, int* nWidth, int* nHeight, BOOL bIRef);
typedef	int		(*LPIPCAM_DECODER_DecodeRGB24_FNC)(HANDLE dwID, BYTE* pBuf, BYTE** pOutImage, DWORD dwLen, int* nWidth, int* nHeight, BOOL bIRef);
typedef	int		(*LPIPCAM_DECODER_GetDimension_FNC)(HANDLE dwID, BYTE* pBuf, DWORD dwLen, int* nWidth, int* nHeight);


